﻿using Prism.Commands;
using Prism.Mvvm;
using Prism.Navigation;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using GridSpanSample.Models;

namespace GridSpanSample.ViewModels
{
    public class MainPageViewModel : OrientationAwareBase, INavigationAware
    {
        private ObservableCollection<MyListViewItem> _itemList;
        private int _spanCount = 1;

        public ObservableCollection<MyListViewItem> ItemList
        {
            get { return _itemList; }
            set { SetProperty(ref _itemList, value); }
        }

        public int SpanCount
        {
            get { return _spanCount; }
            set {SetProperty(ref _spanCount, value); }
        }

        public MainPageViewModel()
        {
            this.GenerateListItems();
        }

        internal void GenerateListItems()
        {
            _itemList = new ObservableCollection<MyListViewItem>
            {
                new MyListViewItem() {Title = "Title one", SubTitle = "Subtitle 1"},
                new MyListViewItem() {Title = "Title two", SubTitle = "Subtitle 2"},
                new MyListViewItem() {Title = "Title three", SubTitle = "Subtitle 3"},
                new MyListViewItem() {Title = "Title four", SubTitle = "Subtitle 4"},
                new MyListViewItem() {Title = "Title five", SubTitle = "Subtitle 5"},
                new MyListViewItem() {Title = "Title six", SubTitle = "Subtitle 6"},
                new MyListViewItem() {Title = "Title seven", SubTitle = "Subtitle 7"},
                new MyListViewItem() {Title = "Title eight", SubTitle = "Subtitle 8"}
            };
        }

        public override void OnPortraitMode()
        {
            Debug.WriteLine("OnPortraitMode");

            // set spanCount
            this.SpanCount = 2;
        }

        public override void OnLandscapeMode()
        {
            Debug.WriteLine("OnLandscapeMode");

            // set spanCount
            this.SpanCount = 4;

        }

        public void OnNavigatedFrom(INavigationParameters parameters)
        {
            
        }

        public void OnNavigatedTo(INavigationParameters parameters)
        {
            
        }
    }
}
